

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable A16Base 0x0000
    variable A24Base 0x000000
    variable A32Base 0x02000000

    variable Base $A32Base
    variable AddrMod 0x09     ;#  A32UD
    variable DWidth  16

    variable online 0
    variable overflow 0
    variable zero 0
    variable alladcs 0
    variable allmodules 0
    variable step 0
    variable fastclear 40

    variable OperationMode 0
    for {set i 0} {$i < 32} {incr i} {variable Enable$i 1}
    for {set i 0} {$i < 32} {incr i} {variable Threshold$i $i}

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

   proc show_variables {} {
        variable A16Base
        variable A24Base
        variable A32Base
        variable Base
        variable ShowLogFlag
        variable LogFlag
        variable JS
        variable alladcs

         if {$ShowLogFlag == 1} {
             EmptyLog
             InsertLog "A16Base=$A16Base; A24Base=$A24Base; A32Base=$A32Base"
             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
             InsertLog "Base=$Base"
             InsertLog "alladcs=$alladcs"
         }  else {
             if {$JS == ""} {append JS "alert(\""}
             append JS "A16Base=$A16Base; A24Base=$A24Base; A32Base=$A32Base;"
             append JS "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag;"
             append JS "Base=$Base"
             append JS "alladcs=$alladcs"
         }
   }

    proc UpdateModule {} {
        variable Base
        variable AddrMod
        variable DWidth
        variable JS

        variable online
        variable overflow
        variable zero
        variable step
        variable fastclear

        variable OperationMode
        for {set i 0} {$i < 32} {incr i} {variable Enable$i}
        for {set i 0} {$i < 32} {incr i} {variable Threshold$i}

        set address 0x102e     ;#  FastClear
        set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
        if {[first $rc] != 0} {
             if {$JS == ""} {append JS "alert(\""}
             append JS "rdVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod returns rc=[first $rc]; "
        } else {
            set vl [second $rc]
            set fastclear $vl
        }

        set address 0x1032     ;#  Bit Set 2
        set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
        if {[first $rc] != 0} {
             if {$JS == ""} {append JS "alert(\""}
             append JS "rdVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod returns rc=[first $rc]; "
        } else {
            set vl [second $rc]
            set OperationMode $vl
            set online [expr $vl >> 1 & 1]
            set overflow [expr $vl >> 3 & 1]
            set zero [expr $vl >> 4 & 1]
            set step [expr $vl >> 8 & 1]
        }

        for {set i 0; set address 0x1080} {$i < 32} {incr i 1; incr address 2} {
            set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
            if {[first $rc] != 0} {
                if {$JS == ""} {append JS "alert(\""}
                append JS "rdVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod returns rc=[first $rc]; "
                break
            }
            set Threshold$i [expr [second $rc] & 255]
            set Enable$i [expr ([second $rc] >> 8) & 1]
        }
   }

    proc do_SetOperationMode {w v} {
        variable Base
        variable AddrMod
        variable DWidth
        variable JS

       switch $w {
           ONLINE    {set data 0x02}
           OVERFLOW  {set data 0x08}
           THRESHOLD {set data 0x10}
           VALC      {set data 0x20}
           SSE       {set data 0x80}
           SSSE      {set data 0x2000}
           STEP      {set data 0x100}
           CSS       {set data 0x400}
           EVMODE    {set data 0x1000}
           EVCMODE   {set data 0x4000}
           BIT15     {set data 0x8000}
       }

       switch $v {
          0         {set address 0x1034}   ;#  Bit_Set_2
          1         {set address 0x1032}   ;#  Bit_Clear_2
       }

       set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $data]
       if {[first $rc] != 0} {
           if {$JS == ""} {append JS "alert(\""}
           append JS "wtVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod returns rc=[first $rc]; "
       }
    }

    proc do_OperationMode {v} {
        variable Base
        variable AddrMod
        variable DWidth
        variable JS

       set address 0x1034   ;#  Bit_Clear_2
       set data 0xffff
       set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $data]
       if {[first $rc] != 0} {
           if {$JS == ""} {append JS "alert(\""}
           append JS "wtVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod returns rc=[first $rc]; "
       }

       set address 0x1032   ;#  Bit_Set_2
       set data $v
       set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $data]
       if {[first $rc] != 0} {
           if {$JS == ""} {append JS "alert(\""}
           append JS "wtVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod returns rc=[first $rc]; "
       }

    }

     proc do_threshold {j vl} {
        variable Base
        variable AddrMod
        variable DWidth
        variable JS
        variable alladcs

        for {set i 0} {$i < 32} {incr i} {variable Enable$i}
        for {set i 0} {$i < 32} {incr i} {variable Threshold$i}

        set address 0x1080   ;# threshold+enable

        for {set i 0} {$i < 32} {incr i 1; incr address 2} {
            if {$j == $i || $alladcs == 1} {
                set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d [expr ([set Enable$i] << 8) + $vl]]
                if {[first $rc] != 0} {
                    if {$JS == ""} {append JS "alert(\""}
                    append JS "wtVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod returns rc=[first $rc]; "
                    break
                } else {
                    InsertLog "V785: Set Threshold $i = $vl"
                    set Threshold$i $vl
                }
            }
        }
     }

     proc do_fastclear {vl} {
        variable Base
        variable AddrMod
        variable DWidth
        variable JS
        variable fastclear

        set address 0x102e   ;# fast clear

        set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $vl]
        if {[first $rc] != 0} {
             if {$JS == ""} {append JS "alert(\""}
             append JS "wtVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod returns rc=[first $rc]; "
        } else {
             InsertLog "V785: Set Fast Clear Windows = $vl"
             set fastclear $vl
        }
     }

     proc do_enable {j vl} {
        variable Base
        variable AddrMod
        variable DWidth
        variable JS
        variable alladcs

        for {set i 0} {$i < 32} {incr i} {variable Enable$i}
        for {set i 0} {$i < 32} {incr i} {variable Threshold$i}

        set address 0x1080   ;# threshold+enable

        if {$vl == "true"} {set Vl 0} else {set Vl 1}

        for {set i 0} {$i < 32} {incr i 1; incr address 2} {
            if {$j == $i || $alladcs == 1} {
                set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d [expr ($Vl << 8) + [set Threshold$i]]]
                if {[first $rc] != 0} {
                    if {$JS == ""} {append JS "alert(\""}
                    append JS "wtVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod returns rc=[first $rc]; "
                    break
                } else {
                    InsertLog "V785: Set Enable $i = $vl"
                    set Enable$i $vl
                }
            }
        }
     }

    proc do_Save {} {
        upvar #0 VMEAccessServer_ConfigBase ConfigBase
        variable JS
        variable Base

        variable OperationMode
        variable fastclear
        for {set i 0} {$i < 32} {incr i} {variable Enable$i}
        for {set i 0} {$i < 32} {incr i} {variable Threshold$i}

        InsertLog "Saving Settings for CAEN V785 module at address $Base"

        set SaveFile [file join $ConfigBase V785[set Base].dat]

        set z [catch {open $SaveFile w} file]
        if {$z != 0} {
            append JS "alert(\"Unable to access $SaveFile\");"
            InsertLog "[set file]"
            return
        }

        puts $file "OperationMode $OperationMode"
        puts $file "FastClear $fastclear"

        for {set i 0} {$i < 32} {incr i} {
            puts $file "Threshold$i [set Threshold$i]"
            puts $file "Enable$i [set Enable$i]"
        }

        close $file

        InsertLog "Done"

        Elog INFORMATION "Settings for CAEN V785 module at address $Base updated in $SaveFile"
    }

    proc do_Restore {} {
        upvar #0 VMEAccessServer_ConfigBase ConfigBase
        variable JS
        variable Base

        InsertLog "Restoring Settings for CAEN V785 module at address $Base"

        set SaveFile [file join $ConfigBase V785[set Base].dat]

        set z [catch {open $SaveFile r} file]
        if {$z != 0} {
            append JS "alert(\"Unable to access $SaveFile\");"
            InsertLog "[set file]"
            return
        }

        foreach item [split [read $file] \n] {
            if {[string length $item] == 0} {continue}
            set p [first $item]
            set vl [second $item]
            switch -glob $p {
                OperationMode   {do_OperationMode $vl}
                FastClear       {do_fastclear $vl}
                Threshold*      {do_threshold [string range $p 9 end] $vl}
                Enable*         {
                   if {$vl == 0} {set vl true} else {set vl false}
                   do_enable [string range $p 6 end] $vl
                }
            }
        }

        close $file

        InsertLog "Done"

        Elog INFORMATION "Settings for CAEN V785 module at address $Base restored from $SaveFile"
    }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   ALLADCS  {variable alladcs; set alladcs [expr ($alladcs + 1) & 1]}

                   ADDRESS  {
                         switch [lindex $w 1] {
                             A16   {variable A16Base; set A16Base [lindex $w 2]; InsertLog "A16 Base = $A16Base"}
                             A24   {variable A24Base; set A24Base [lindex $w 2]; InsertLog "A24 Base = $A24Base"}
                             A32   {variable A32Base; set A32Base [lindex $w 2]; InsertLog "A32 Base = $A32Base"; variable Base; set Base $A32Base}
                         }
                   }

                   OFFSET  {
                       set i [lindex $w 1]
                       if {$i < 32} {UpdateModule; do_threshold $i [lindex $w 2]}
                       if {$i == 32} {do_fastclear [lindex $w 2]}
                   }

                   ENABLE  {UpdateModule; do_enable [lindex $w 1] [lindex $w 2]}

                   ONLINE    {do_SetOperationMode ONLINE [lindex $w 1]}
                   OVERFLOW  {do_SetOperationMode OVERFLOW [lindex $w 1]}
                   STEP      {do_SetOperationMode STEP [lindex $w 1]}
                   ZERO      {do_SetOperationMode THRESHOLD [lindex $w 1]}

                   SAVE      {UpdateModule; do_Save}
                   RESTORE   {do_Restore}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

}   ;# end of if {$started == 0}

